package dominio;

import gui.JPLineas;

import java.util.Enumeration;
import java.util.Hashtable;
import java.util.Vector;

public class Centralita {
	protected Hashtable<String, Telefono> telefonos=new Hashtable<String, Telefono>();
	protected Hashtable<String, Linea> lineas=new Hashtable<String, Linea>();
	protected Hashtable<String, Retrollamada> retrollamadas=new Hashtable<String, Retrollamada>();
	private JPLineas gui;
	
	public Centralita(JPLineas gui) {
		this.gui=gui;
	}
	
	public void add(Telefono t) {
		telefonos.put(t.getNumero(), t);
	}

	public synchronized void solicitarLinea(Telefono t) {
		if (lineasLibres()) {
			System.out.println("Hay lnea");
			Linea l=new Linea(this, t);
			add(t, l);
			t.tonoDeMarcar();
		} else {
			System.out.println("No hay lnea");
			t.tonoDeOcupado();
		}
	}

	private synchronized void add(Telefono emisor, Linea l) {
		lineas.put(emisor.getNumero(), l);
		Vector<String> row=new Vector<String>();
		row.add(l.getEmisor().getNumero());
		row.add(""); row.add("");
		if (gui!=null)
			gui.addRow(row);
	}

	private synchronized boolean lineasLibres() {
		return this.lineas.size()<5;
	}

	public synchronized void responder(Telefono t) {
		Linea l=findLineaDelReceptor(t);
		l.habilitarConversacion();
	}

	private synchronized Linea findLineaDelReceptor(Telefono receptor) {
		Enumeration<Linea> e=lineas.elements();
		while (e.hasMoreElements()) {
			Linea l=e.nextElement();
			if (l.getReceptor().getNumero().equals(receptor.getNumero()))
				return l;
		}
		return null;
	}

	public synchronized void marcar(Telefono emisor, int digito) {
		Linea l=lineas.get(emisor.getNumero());
		if (l==null) return;
		if (gui!=null)
			this.gui.marcar(emisor.getNumero(), digito);
		l.add(digito);
		if (!existe(l.getSecuencia())) {
			emisor.numeroNoExiste();
			this.liberarLineaNoUsada(emisor);
			return;
		}
		Telefono receptor=this.telefonos.get(l.getSecuencia());
		if (receptor!=null) {
			if (receptor.getEstado()==EstadosTelefono.EN_SILENCIO) {
				l.setReceptor(receptor);
			}
			emisor.tonoDeOcupado();
		}
	}

	public synchronized void liberar(Linea l) {
		lineas.remove(l.getEmisor().getNumero());
		l.terminar();
		if (gui!=null)
			this.gui.remove(l.getEmisor().getNumero());		
	}

	private synchronized boolean existe(String secuencia) {
		Enumeration<Telefono> e=telefonos.elements();
		while (e.hasMoreElements()) {
			Telefono t=e.nextElement();
			if (t.getNumero().startsWith(secuencia))
				return true;
		}
		return false;
	}

	public synchronized void solicitarRetrollamada(Telefono t) {
		Linea l=lineas.get(t.getNumero());
		Retrollamada r=new Retrollamada(l.getEmisor(), l.getReceptor());
		this.retrollamadas.put(l.getReceptor().getNumero(), r);
	}

	public synchronized void anularRetrollamada(Telefono t) {
		Enumeration<Retrollamada> e=this.retrollamadas.elements();
		while (e.hasMoreElements()) {
			Retrollamada r=e.nextElement();
			if (r.getEmisor().getNumero().equals(t.getNumero())) {
				this.retrollamadas.remove(r.getEmisor().getNumero());
				return;
			}
		}
	}

	public synchronized void setTime(Linea linea, long time) {
		if (gui!=null)
			this.gui.setTime(linea.getEmisor().getNumero(), time);
	}

	public synchronized void finalizarConversacionReceptor(Telefono receptor) {
		Linea l=this.findLineaDelReceptor(receptor);
		l.finalizarConversacionReceptor(receptor);
		this.liberar(l);
	}

	public synchronized void liberarLineaNoUsada(Telefono emisor) {
		Linea l=this.lineas.get(emisor.getNumero());
		if (l!=null)
			this.liberar(l);
	}

	public synchronized void finalizarConversacionEmisor(Telefono emisor) {
		Linea l=this.lineas.get(emisor.getNumero());
		l.finalizarConversacionEmisor(emisor);
		this.liberar(l);
	}

	public void colgadoSimple(Telefono telefono) {
		// TODO Auto-generated method stub	
	}
}
