package dominio;

public class Linea {
	private Telefono emisor, receptor;
	private String secuencia;
	private Reloj reloj;
	private Thread hilo;
	private Centralita centralita;

	public Linea(Centralita centralita, Telefono t) {
		this.centralita=centralita;
		this.emisor=t;
		this.secuencia="";
		this.reloj=new Reloj(this);
		this.hilo=new Thread(reloj);
		this.reloj.iniciarTiempo();
		this.hilo.start();
	}

	public void add(int digito) {
		this.secuencia+=digito;
		reloj.iniciarTiempo();
	}

	public String getSecuencia() {
		return this.secuencia;
	}

	public Telefono getReceptor() {
		return receptor;
	}

	public void habilitarConversacion() {
		emisor.habilitarConversacionComoEmisor();
		receptor.habilitarConversacionComoReceptor();
		reloj.detener();
	}

	public Telefono getEmisor() {
		return emisor;
	}

	public void liberar() {
		this.centralita.liberar(this);
	}

	public void habilitaRetrollamada() {
		// TODO Auto-generated method stub		
	}

	public void setTime(long time) {
		this.centralita.setTime(this, time);
	}

	public void setReceptor(Telefono receptor) {
		this.receptor=receptor;
		this.receptor.timbre();
		this.emisor.tonoDeLlamada();
	}

	public void finalizarConversacionReceptor(Telefono receptor) {
		this.emisor.tonoDeOcupado();
	}

	public void finalizarConversacionEmisor(Telefono emisor) {
		this.receptor.tonoDeOcupado();
	}

	public void terminar() {
		this.reloj.detener();
		this.hilo.interrupt();
	}
}
