package gui;

import javax.swing.SwingUtilities;
import java.awt.BorderLayout;
import javax.swing.JPanel;
import javax.swing.JFrame;

import dominio.Centralita;
import dominio.Telefono;

import java.awt.Dimension;
import javax.swing.JTabbedPane;
import java.awt.Rectangle;
import javax.swing.JScrollPane;
import javax.swing.JTable;

public class JFCentralita extends JFrame {

	private static final long serialVersionUID = 1L;

	private JPanel jContentPane = null;

	private Centralita centralita;

	private JTabbedPane jTabbedPane = null;

	private JPLineas jpLineas = null;

	/**
	 * This method initializes jTabbedPane	
	 * 	
	 * @return javax.swing.JTabbedPane	
	 */
	private JTabbedPane getJTabbedPane() {
		if (jTabbedPane == null) {
			jTabbedPane = new JTabbedPane();
			jTabbedPane.setBounds(new Rectangle(644, 3, 350, 308));
		}
		return jTabbedPane;
	}

	/**
	 * This method initializes jpLineas	
	 * 	
	 * @return gui.JPLineas	
	 */
	private JPLineas getJpLineas() {
		if (jpLineas == null) {
			jpLineas = new JPLineas();
			jpLineas.setBounds(new Rectangle(11, 381, 631, 79));
		}
		return jpLineas;
	}

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		
		SwingUtilities.invokeLater(new Runnable() {
			public void run() {
				JFCentralita thisClass = new JFCentralita();
				thisClass.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
				thisClass.setVisible(true);
			}
		});
	}

	/**
	 * This is the default constructor
	 */
	public JFCentralita() {
		super();
		initialize();
		this.centralita=new Centralita(this.jpLineas);
		int cont=0;
		for (int i=0; i<5; i++) {
			for (int j=0; j<5; j++) {
				Telefono t=new Telefono(this.centralita, cont++);
				this.centralita.add(t);
				JPTelefono jb=new JPTelefono(t);
				t.setGui(jb);
				jb.setLocation(i*100, j*70);
				this.jContentPane.add(jb);
				JPTeclado jp=new JPTeclado(t);
				this.jTabbedPane.add(t.getNumero(), jp);
			}
		}
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setSize(1006, 503);
		this.setContentPane(getJContentPane());
		this.setTitle("JFrame");
	}

	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jContentPane = new JPanel();
			jContentPane.setLayout(null);
			jContentPane.add(getJTabbedPane(), null);
			jContentPane.add(getJpLineas(), null);
		}
		return jContentPane;
	}

}  //  @jve:decl-index=0:visual-constraint="10,10"
