package gui;

import javax.swing.JScrollPane;
import java.awt.Dimension;
import java.util.Vector;

import javax.swing.JTable;
import javax.swing.table.DefaultTableModel;

public class JPLineas extends JScrollPane {

	private static final long serialVersionUID = 1L;
	private JTable jtLineas = null;
	private DefaultTableModel modeloLineas=null;

	/**
	 * This is the default constructor
	 */
	public JPLineas() {
		super();
		initialize();
		this.modeloLineas=new DefaultTableModel();
		String[] cabs={"Emisor", "Receptor", "Tiempo"};
		this.modeloLineas.setColumnIdentifiers(cabs);
		this.jtLineas.setModel(modeloLineas);
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setSize(624, 126);

		this.setViewportView(getJtLineas());
	}

	/**
	 * This method initializes jtLineas	
	 * 	
	 * @return javax.swing.JTable	
	 */
	private JTable getJtLineas() {
		if (jtLineas == null) {
			jtLineas = new JTable();
		}
		return jtLineas;
	}

	public void addRow(Vector<String> row) {
		this.modeloLineas.addRow(row);
	}

	public void marcar(String numero, int digito) {
		for (int i=0; i<this.modeloLineas.getRowCount(); i++) {
			String emisor=this.modeloLineas.getValueAt(i, 0).toString();
			if (emisor.equals(numero)) {
				String receptor=this.modeloLineas.getValueAt(i, 1).toString();
				this.modeloLineas.setValueAt(receptor+digito, i, 1);
				return;
			}
		}
	}

	public void remove(String numero) {
		for (int i=0; i<this.modeloLineas.getRowCount(); i++) {
			String emisor=this.modeloLineas.getValueAt(i, 0).toString();
			if (emisor.equals(numero)) {
				this.modeloLineas.removeRow(i);
				return;
			}
		}
	}

	public void setTime(String numero, long tiempo) {
		for (int i=0; i<this.modeloLineas.getRowCount(); i++) {
			String emisor=this.modeloLineas.getValueAt(i, 0).toString();
			if (emisor.equals(numero)) {
				this.modeloLineas.setValueAt(tiempo, i, 2);
				return;
			}
		}
	}

}  //  @jve:decl-index=0:visual-constraint="10,10"
