package gui;

import java.awt.Color;
import java.awt.GridBagLayout;
import javax.swing.JPanel;
import java.awt.Dimension;
import javax.swing.JLabel;

import dominio.EstadosTelefono;
import dominio.Telefono;

import java.awt.GridBagConstraints;
import java.awt.Rectangle;
import java.awt.Font;
import javax.swing.BorderFactory;

public class JPTelefono extends JPanel {

	private static final long serialVersionUID = 1L;
	private JLabel jlNumero = null;
	private JLabel jlEstado = null;
	protected Telefono telefono;

	/**
	 * This is the default constructor
	 */
	public JPTelefono(Telefono telefono) {
		super();
		initialize();
		this.telefono=telefono;
		this.jlNumero.setText(this.telefono.getNumero());
		updateState(this.telefono.getEstado());
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		jlEstado = new JLabel();
		jlEstado.setText("JLabel");
		jlEstado.setFont(new Font("Dialog", Font.BOLD, 10));
		jlEstado.setBounds(new Rectangle(5, 36, 93, 16));
		jlNumero = new JLabel();
		jlNumero.setText("JLabel");
		jlNumero.setBounds(new Rectangle(5, 11, 94, 16));
		this.setSize(100, 70);
		this.setLayout(null);
		this.setBorder(BorderFactory.createLineBorder(Color.black, 1));
		this.add(jlNumero, null);
		this.add(jlEstado, null);
	}

	public void updateState(int estado) {
		String st=EstadosTelefono.getMensaje(estado);
		this.jlEstado.setText(st);		
	}
}  //  @jve:decl-index=0:visual-constraint="10,10"
